// -------------------------------------------------------------
// animate.h
//

#ifndef ANIMATE_H
#define ANIMATE_H

// Text animations
#include "config.h" // configuration
#include "ctl.h" // control/trhead
#include "machine.h" // machine state

#include <stdlib.h> // for malloc
#include <string.h> // for strlen

// datastructure for containment of "lichtkrant" scroll
struct TXT_Scroll
{
	char *text;
	int text_length;
	
	int offset;
	int p;
	int dir;
};

CTL_Thread *ctl_thread_add_text_scroll( CTL_Thread *parent, int wakeup, char *text, int offset, int dir);


// a welcome scroll are nice animated arrows pointing a certain way
// can be either scrolling to left or to right
struct Welcome_Scroll
{
	// A scrolling thing that displays "arrows" going to one side.
	int from;
	int to;
	int dir;
	int i;
};

CTL_Thread *ctl_thread_add_welcome_scroll( CTL_Thread *parent, int wakeup, int from, int to, int dir);

// blinking text, yay
struct TXT_Blink
{
	char *text_a;
	char *text_b;
	int text_length;
	
	int offset;
	int i;
};

CTL_Thread *ctl_thread_add_text_blink( CTL_Thread *parent, int wakeup, int offset, char *text_a, char *text_b);

	
#endif
