// -------------------------------------------------------------
// ctl.h
//

#ifndef CTL_H
#define CTL_H

// "Threading" control.

// A linked list of threads, each of which will be called from the main loop,
// when the tick MOD the wakeup == 0.
struct CTL_Thread
{
	void (*thread_function)(CTL_Thread *); // The "tick" function, function pointer
	int wakeup; // When to wake up -- every X cycles: 1 is the fastests (every cycle)
	void *state; // Thread state -- can by anything.
	struct CTL_Thread *next; // A pointer to the next thread
};


CTL_Thread *ctl_thread_new( void (*thread_function)(CTL_Thread *), void *state, int wakeup);
void ctl_thread_add( CTL_Thread *thread, CTL_Thread *next);
int ctl_thread_del( CTL_Thread *thread, CTL_Thread *to_delete);
void ctl_thread_set_wakeup( CTL_Thread *thread, int wakeup);

#endif
