// -------------------------------------------------------------
// eeprom.h
//

//
// Read EEPROM chips on arduino over I2C.

#ifndef EEPROM_H
#define EEPROM_H

// I have bought 2 chips of type 24LC512, that are each 65 kilobytes.
// They are attached to a prototyping board on top of the arduino.
#define MAX_ADDR 65535

// we read from the memory modules in chunks of 24 bytes.
#define PAGE_SIZE 24

// a data structure to read an EEPROM chip.
struct EEPROM
{
	int addr; // the address;
	// either 0x50 for the first chip,
	// or 0x51 for the second chip.
	// I might add more chips in the future..
	
	int cur; // current address we're reading
	int max; // the limit
};


// function definitions
EEPROM *eeprom_init(int addr);
char *eeprom_read_line(EEPROM *e);

//EEPROM *eeprom_reset(int addr); // FIXME?

#endif
