// -------------------------------------------------------------
// ctl.cpp
//

#include <stdlib.h> // malloc()

#include "ctl.h"

// the main threading code

CTL_Thread *ctl_thread_new( void (*thread_function)(CTL_Thread *), void *state, int wakeup)
{
	CTL_Thread *t;
	t = (CTL_Thread *)malloc(sizeof(CTL_Thread));
	t->thread_function = thread_function;

	t->state  = state;
	t->wakeup = wakeup;
	t->next   = 0; 
	
	return t;
}

/**
 * Add <next> to the tail of the linked list
 */
void ctl_thread_add( CTL_Thread *thread, CTL_Thread *next)
{
	while (thread->next) thread = thread->next;
	thread->next = next;
}

/**
 * Delete <to_del> from the linked list
 */
int ctl_thread_del( CTL_Thread *thread, CTL_Thread *to_delete)
{
	CTL_Thread *prev = 0;

	while (thread != to_delete)
	{
		if (!thread->next)
		{
			return 0; // failed
		}

		prev   = thread;
		thread = thread->next;
	}

	// found it, lets delete it
	if (thread->next && prev)
	{
		prev->next = thread->next;
	}

	free(thread);
	return 1;
}

void ctl_thread_set_wakeup( CTL_Thread *thread, int wakeup)
{
	thread->wakeup = wakeup;
}



