#ifdef SIMULATOR

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define TICK_SPEED 5000   // the per-tick speed; global speed constant.

#include "ctl.h"
#include "machine.h"
#include "animate.h"


void print_cb(struct CTL_Thread *thread)
{
	machine_sync();
}


int main ()
{
	struct CTL_Thread *start, *thr;

	start = ctl_thread_new(0, 0, 0); // empty starting point

	ctl_thread_add(start, ctl_thread_new(&print_cb, 0, 10));
	//ctl_thread_add(start, ctl_thread_new(&cb2, 0, 11));
	ctl_thread_add_text_scroll(start, 10, " Hello ", 0, -1);
	ctl_thread_add_text_scroll(start, 10, "  Doei ", 10, 1);
	
	machine_clear();

	int tick = 0;
	while (1)
	{
		thr = start;
		do
		{
			if (thr->thread_function && thr->wakeup && !(tick%thr->wakeup))
			{
				thr->thread_function(thr);
			}
			thr = thr->next;
		} while (thr);
		tick++;

		usleep(MACHINE_TICK_SPEED);
	}

	return 0;
}

#endif
