from twisted.internet    import serialport, protocol
from twisted.application import service


class ControllerInput(serialport.SerialPort, service.Service):

    _size = None
    
    def __init__ (self, device, *args, **kw):
        from twisted.internet import reactor           
        
        serialport.SerialPort.__init__(self, ControllerInputProtocol(), device, reactor, *args, **kw)

    def set_data (self, str):
        """ Data was received in the serial port; set it in the parent (which is a Logic service). """
        check = ord(str[0])
        if check != 255:
            return # invalid data given

        size = ord(str[1])
        if len(str[2:]) != size:
            print "Warning, protocol error, expected %d, got %d" % (size, len(str[2:]))
            return # invalid size
        
        if not self._size or self._size != size:
            self.parent.resize(size)
            self._size = size

        self.parent.set(0, str[2:])

class ControllerInputProtocol (protocol.Protocol):

    _data = ""
    
    def dataReceived (self, data):
        if not self._data and ord(data[0]) != 255:
            return

        self._data += data
        
        p = self._data[1:].find(chr(255))+1
        if p > 0:
            chunk = self._data[:p]
            self.transport.set_data(chunk)
            self._data = self._data[p:]
    
