#!/usr/bin/python

import sys, re

try:
    prog, mode = sys.argv
except ValueError:
    print "Usage: striptocomments <mode> where mode = (c++, c, python)"
    exit()

all = sys.stdin.read()

if mode == 'c++':

    # strip everything before the //
    for line in all.split("\n"):
        p = line.find("//")
        try:
            rest = line.split("//", 1)[1].strip()
            print "// " + rest
        except IndexError:
            pass

elif mode == 'c':
    all = re.sub('\s+', ' ', all) # strip all spaces

    commentstart = 0
    commentend   = 0
    comment = False

    while True:
        if not comment:
            commentstart = all.find("/*", commentend)
            if commentstart == -1:
                break # end of code reached
            
            comment = True
        else:

            commentend = all.find("*/", commentstart)
            if commentstart == -1:
                break # syntax error? code stopped in middle of a comment

            print all[commentstart:commentend+2]
            comment = False
            pass
    pass

elif mode == 'python':

    # strip everything before the //
    for line in all.split("\n"):
        p = line.find("#")
        try:
            rest = line.split("#", 1)[1].strip()
            print "# " + rest
        except IndexError:
            pass



#print all
