;;; ************************************************************
;;; Control code for the vga.
;;; Arjan Scherpenisse <arjan@scherpenisse.net>, may 2009
;;; This code is released in the public domain.
;;; ************************************************************

        LIST P=16F627, R=DEC    ; Use the PIC16F628 and decimal system

        #include "p16f627.inc"  ; Include header file
        
        __config  _EXTCLK_OSC & _LVP_OFF & _WDT_OFF & _PWRTE_ON & _BODEN_ON 

        CBLOCK 0x20             ; Declare variable addresses starting at 0x20
          hloop, vloop		; hsync and vsync loop variables
	
	  dataline 		; data-variable for the b/w pixel data

	  data0, data1, data2, data3, data4, data5, data6
				; 7 data variables for the pixel rows
	
	  charaddr, offset
				; address of current char
        ENDC

#define P_HSYNC PORTA,1
#define P_VSYNC PORTA,0
#define P_GREEN PORTA,3
#define P_BLUE  PORTA,2
	
;
; -----------
; INITIALIZE
; -----------
;
        ORG    0x000           ; Program starts at 0x000

	
        CLRF   PORTA           ; Initialize port A
        CLRF   PORTB           ; Initialize port B

        BSF    STATUS,RP0      ; RAM bank 1

        CLRF   TRISA           ; All pins port A output
        MOVLW   0xFF            
        MOVWF   TRISB           ; PORTB input

        BCF    STATUS,RP0      ; RAM bank 0
;
; ------------------------
; FUNCTION OF PORT A PINS
; ------------------------
;
        MOVLW    7
        MOVWF    CMCON         ; Comparators off, all pins digital I/O

	goto start
